;Window Sizer
;
;This little program resizes any visible window on your desktop.  It has some basic error handling and the such.  I feel this could be somewhat usefull to a webpage designer to see exactly what his/her page looks at specific sizes.
;
;
;Sorry for the lack of a make file but i wrote this program with Hutch's Masm32 package and
;compiled it with the same thing. I recomend using his package or at least his includes.  Visit 
;http://win32asm.cjb.net to get it.
;
;if you want to do it through dos compile like so
;
;ml /c /coff /Cp sizer.asm
;link /SUBSYSTEM:WINDOWS /LIBPATH:c:\masm32\lib sizer.obj sizer.res
.386
.model flat,stdcall
option casemap:none
include windows.inc
include user32.inc
include kernel32.inc
includelib user32.lib
includelib kernel32.lib
WndProc proto:dword,:dword,:dword,:dword
 ;forward declare of used functions
EnumProc proto:dword,:dword
FindProc proto:HWND,:BOOL
Subtract macro first,second
 ;Macros need through out the code
 mov eax,first
 sub eax,second
 mov first,eax
endm
LOWORD macro bigword
 mov eax,bigword
 and eax,0FFFFh
endm
HIWORD macro bigword
 mov eax,bigword
 shr eax,16
endm
.data
 dlgname db "MAIN",0
 szProgman db "Program Manager",0
 szAbout db "Coded by: Betrayed",13,10
  db "Coded in: Asm(Masm)",13,10
  db "E-mail: odin77@hotmail.com",13,10
  db "Home page: http://betrayed.virtualave.net",0
 szPlease db "Please select an item from the list box",0
 szMin db "Window is minimized.",13,10
  db "Would you like to restore it?",0
 szNoWin db "Specified Window could not be found.",13,10
  db "Refreshing Window list...",0
 szBadSize db "Please Choose a non zero, numeric size.",0
 szTitle db "Window Sizer",0
.data?
 hInstance dd ?
 hList dd ?
 ident dd ?
 coorX dd ?
 coorY dd ?
 coorL dd ?
 coorT dd ?
.code
 start:
 invoke GetModuleHandle,NULL
 mov hInstance,eax
 invoke DialogBoxParam,hInstance,addr dlgname,0,addr WndProc,0
 invoke ExitProcess,eax
 WndProc proc hWin:dword,uMsg:dword,wParam:dword,lParam:dword
  .if uMsg==WM_INITDIALOG
   invoke LoadIcon,hInstance,100
   invoke SendMessage,hWin,WM_SETICON,1,eax
   invoke SetWindowPos,hWin,HWND_TOP,NULL,NULL,NULL,NULL,SWP_NOMOVE+SWP_NOSIZE
    ;window on top
   invoke GetDlgItem,hWin,1000
    ;Get listbox
   mov hList,eax
    ;save handle
   invoke EnumWindows,addr EnumProc,NULL
    ;enumerate the windows
   invoke SetFocus,hList
    ;Set focus on the listbox
   xor eax,eax
   ret
  .elseif uMsg==WM_COMMAND
   LOWORD wParam
    ;loword returns the id code
   .if eax==3002
    ;close button
    invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
     ;close it
   .elseif eax==3001
    ;about button
    invoke MessageBox,hWin,addr szAbout,addr szTitle,MB_OK+MB_ICONINFORMATION
   .elseif eax==2003
    ;set button
    invoke FindProc,hWin,TRUE
     ;call findprco with true so it knows to set a new size
   .elseif eax==3000
    ;refresh button
    invoke SendMessage,hList,LB_RESETCONTENT,NULL,NULL
     ;clear listbox
    invoke EnumWindows,addr EnumProc,NULL
     ;enumerate the windows
    invoke SetFocus,hList
     ;set focus on the listbox
   .elseif eax==1000
    ;listbox
    HIWORD wParam
     ;hiword shows the message sent (fix from previous version)
    .if eax==LBN_SELCHANGE
     ;if it is a change in the selection we want to know
     invoke FindProc,hWin,FALSE                          ;Call findproc with false so we just update the sizebox
                    .endif
            .endif
            xor eax,eax
                ret
      .elseif uMsg == WM_CLOSE
        invoke ShowWindow,hWin,SW_MINIMIZE      ;just a little bit of end eyecandy =P
        invoke EndDialog,hWin,0
            xor eax,eax
            ret
      .endif
    xor eax,eax
    ret
WndProc endp
 EnumProc proc eHandle:dword,y:dword
  local buffer[1024]:byte
  local un:dword
  invoke IsWindowVisible,eHandle
   ;see if it is visble
  .if eax
   ;if it is go on
   invoke GetWindowText,eHandle,addr buffer,sizeof buffer
    ;get the text
   .if eax
    ;make sure it has text
    invoke lstrcmp,addr szProgman,addr buffer
     ;compare it to the program manager
    mov un,eax
     ;save result
    invoke lstrcmp,addr szTitle,addr buffer
     ;compare it to our title
    .if !(un==0||eax==0)
     ;if neither match go on
     invoke SendMessage,hList,LB_ADDSTRING,NULL,addr buffer
      ;and add it to the list box
    .endif
   .endif
  .endif
  mov eax,eHandle
   ;enumerate until the handle is zero
  ret
 EnumProc endp
 FindProc proc hWnd:HWND,which:BOOL
  LOCAL buffer2[1024]:BYTE
  LOCAL IndexItem:DWORD
  LOCAL handle:HWND
  LOCAL rectWin:RECT
  invoke SendMessage,hList,LB_GETCURSEL,0,0
   ;get the selection position
  mov IndexItem,eax
   ;save it
  .if eax!=LB_ERR
   ;make sure something is selected
   invoke SendMessage,hList,LB_GETTEXT,IndexItem,addr buffer2
    ;get the selected text
   invoke FindWindow,NULL,addr buffer2
    ;use it to find the window
   mov handle,eax
    ;save the handle
   .if eax!=NULL
    ;make sure we have a handle
    .if which==TRUE
     ;see what we want to do with this function
     invoke IsIconic,handle
      ;since it was true we want to resize and we need to know if it is minimized
     .if !eax
      ;if it is not go on
      invoke GetDlgItemInt,hWnd,2004,NULL,0
      mov coorL,eax
      invoke GetDlgItemInt,hWnd,2005,NULL,0
      mov coorT,eax
      invoke GetDlgItemInt,hWnd,2000,NULL,0
       ;get width we want to resize to
      mov coorX,eax
       ;save it
      invoke GetDlgItemInt,hWnd,2001,NULL,0
       ;get the height to resize to
      mov coorY,eax
       ;save it
      .if !(coorX==0||coorY==0)
       ;make sure neither is zero
       invoke SetWindowPos,handle,HWND_TOP,coorL,coorT,coorX,coorY,SWP_NOZORDER
       ;invoke SetWindowPos,handle,NULL,0,0,coorX,coorY,SWP_NOMOVE+SWP_NOZORDER
        ;http://msdn.microsoft.com/en-us/library/ms633545(VS.85).aspx
         ;SetWindowPos Function
          ;Changes the size, position, and Z order of a child, pop-up, or top-level window. These windows are ordered according to their appearance on the screen. The topmost window receives the highest rank and is the first window in the Z order.
          ;Syntax
           ;BOOL SetWindowPos
            ;(
             ;HWND hWnd,
             ;HWND hWndInsertAfter,
             ;int X,
             ;int Y,
             ;int cx,
             ;int cy,
             ;UINT uFlags
            ;);
          ;Parameters
           ;hWnd
            ;[in] A handle to the window.
           ;hWndInsertAfter
            ;[in] A handle to the window to precede the positioned window in the Z order. This parameter must be a window handle or one of the following values.
             ;HWND_BOTTOM
              ;Places the window at the bottom of the Z order. If the hWnd parameter identifies a topmost window, the window loses its topmost status and is placed at the bottom of all other windows.
             ;HWND_NOTOPMOST
              ;Places the window above all non-topmost windows (that is, behind all topmost windows). This flag has no effect if the window is already a non-topmost window.
             ;HWND_TOP
              ;Places the window at the top of the Z order.
             ;HWND_TOPMOST
              ;Places the window above all non-topmost windows. The window maintains its topmost position even when it is deactivated.
             ;For more information about how this parameter is used, see the following Remarks section.
           ;X
            ;[in] Specifies the new position of the left side of the window, in client coordinates.
           ;Y
            ;[in] Specifies the new position of the top of the window, in client coordinates.
           ;cx
            ;[in] Specifies the new width of the window, in pixels.
           ;cy
            ;[in] Specifies the new height of the window, in pixels.
           ;uFlags
            ;[in] Specifies the window sizing and positioning flags. This parameter can be a combination of the following values.
           ;SWP_ASYNCWINDOWPOS
            ;If the calling thread and the thread that owns the window are attached to different input queues, the system posts the request to the thread that owns the window. This prevents the calling thread from blocking its execution while other threads process the request.
           ;SWP_DEFERERASE
            ;Prevents generation of the WM_SYNCPAINT message.
           ;SWP_DRAWFRAME
            ;Draws a frame (defined in the window's class description) around the window.
           ;SWP_FRAMECHANGED
            ;Applies new frame styles set using the SetWindowLong function. Sends a WM_NCCALCSIZE message to the window, even if the window's size is not being changed. If this flag is not specified, WM_NCCALCSIZE is sent only when the window's size is being changed.
           ;SWP_HIDEWINDOW
            ;Hides the window.
           ;SWP_NOACTIVATE
            ;Does not activate the window. If this flag is not set, the window is activated and moved to the top of either the topmost or non-topmost group (depending on the setting of the hWndInsertAfter parameter).
           ;SWP_NOCOPYBITS
            ;Discards the entire contents of the client area. If this flag is not specified, the valid contents of the client area are saved and copied back into the client area after the window is sized or repositioned.
           ;SWP_NOMOVE
            ;Retains the current position (ignores X and Y parameters).
           ;SWP_NOOWNERZORDER
            ;Does not change the owner window's position in the Z order.
           ;SWP_NOREDRAW
            ;Does not redraw changes. If this flag is set, no repainting of any kind occurs. This applies to the client area, the nonclient area (including the title bar and scroll bars), and any part of the parent window uncovered as a result of the window being moved. When this flag is set, the application must explicitly invalidate or redraw any parts of the window and parent window that need redrawing.
           ;SWP_NOREPOSITION
            ;Same as the SWP_NOOWNERZORDER flag.
           ;SWP_NOSENDCHANGING
            ;Prevents the window from receiving the WM_WINDOWPOSCHANGING message.
           ;SWP_NOSIZE
            ;Retains the current size (ignores the cx and cy parameters).
           ;SWP_NOZORDER
            ;Retains the current Z order (ignores the hWndInsertAfter parameter).
           ;SWP_SHOWWINDOW
            ;Displays the window.
          ;Return Value
           ;If the function succeeds, the return value is nonzero.
           ;If the function fails, the return value is zero. To get extended error information, call GetLastError.
          ;Remarks
           ;As part of the Vista re-architecture, all services were moved off the interactive desktop into Session 0. hwnd and window manager operations are only effective inside a session and cross-session attempts to manipulate the hwnd will fail. For more information, see Session 0 Isolation.
           ;If the SWP_SHOWWINDOW or SWP_HIDEWINDOW flag is set, the window cannot be moved or sized.
           ;If you have changed certain window data using SetWindowLong, you must call SetWindowPos for the changes to take effect. Use the following combination for uFlags: SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED.
           ;A window can be made a topmost window either by setting the hWndInsertAfter parameter to HWND_TOPMOST and ensuring that the SWP_NOZORDER flag is not set, or by setting a window's position in the Z order so that it is above any existing topmost windows. When a non-topmost window is made topmost, its owned windows are also made topmost. Its owners, however, are not changed.
           ;If neither the SWP_NOACTIVATE nor SWP_NOZORDER flag is specified (that is, when the application requests that a window be simultaneously activated and its position in the Z order changed), the value specified in hWndInsertAfter is used only in the following circumstances.
            ;Neither the HWND_TOPMOST nor HWND_NOTOPMOST flag is specified in hWndInsertAfter.
            ;The window identified by hWnd is not the active window.
           ;An application cannot activate an inactive window without also bringing it to the top of the Z order. Applications can change an activated window's position in the Z order without restrictions, or it can activate a window and then move it to the top of the topmost or non-topmost windows.
           ;If a topmost window is repositioned to the bottom (HWND_BOTTOM) of the Z order or after any non-topmost window, it is no longer topmost. When a topmost window is made non-topmost, its owners and its owned windows are also made non-topmost windows.
           ;A non-topmost window can own a topmost window, but the reverse cannot occur. Any window (for example, a dialog box) owned by a topmost window is itself made a topmost window, to ensure that all owned windows stay above their owner.
           ;If an application is not in the foreground, and should be in the foreground, it must call the SetForegroundWindow function.
           ;To use SetWindowPos to bring a window to the top, the process that owns the window must have SetForegroundWindow permission.
        ;resize the window
      .else
       invoke MessageBox,hWnd,addr szBadSize,addr szTitle,MB_OK+MB_ICONSTOP
        ;if zero let the user know about it
      .endif
     .else
      invoke MessageBox,hWnd,addr szMin,addr szTitle,MB_YESNO+MB_ICONSTOP
       ;it is minimized
      .if eax==IDYES
       invoke ShowWindow,handle,SW_RESTORE
        ;asked the user what to do if they chose restore
       invoke SendMessage,hWnd,WM_COMMAND,2003,NULL
        ;and set the size again
      .endif
     .endif
    .else
     ;which was false
     invoke GetWindowRect,handle,addr rectWin
      ;get the window rectangle
     Subtract rectWin.right,rectWin.left
      ;call the macro to subtract
     Subtract rectWin.bottom,rectWin.top
      ;call the macro to subtract
     invoke SetDlgItemInt,hWnd,2004,rectWin.left,0
     invoke SetDlgItemInt,hWnd,2005,rectWin.top,0
     invoke SetDlgItemInt,hWnd,2000,rectWin.right,0
      ;set the size in the width box
     invoke SetDlgItemInt,hWnd,2001,rectWin.bottom,0
      ;set the size in the height box
    .endif
   .else
    invoke MessageBox,hWnd,addr szNoWin,addr szTitle,MB_OK+MB_ICONEXCLAMATION
     ;window could not be found
    invoke SendMessage,hWnd,WM_COMMAND,3000,NULL
     ;refresh the list
   .endif
  .else
   invoke MessageBox,hWnd,addr szPlease,addr szTitle,MB_OK+MB_ICONSTOP
    ;nothing selected in the listbox
  .endif
  xor eax,eax
  ret
 FindProc endp
end start
